﻿class HitBox {
	var hitBoxMC:MovieClip;
	var name:String;
	var id:String;
	var description:String;
	var mcX:Number;
	var mcY:Number;
	var mcWidth:Number;
	var mcHeight:Number
	var location:Location;
	var visible:Boolean = true;
	var active:Boolean = true;
	
	var _isHitBox:Boolean = true;
	
	var eventClick:String;
	var eventUse:String;
	var eventUseWith:String;
	var eventPickUp:String;
	var eventOpen:String;
	var eventClose:String;
	var eventLookAt:String;
	
	function HitBox(posX:Number, posY:Number, m_width:Number, m_height:Number, name:String, id:String) {
		var hBox = this;
		this.name = name;
		this.id = id;
		this.mcX = posX;
		this.mcY = posY;
		this.mcWidth = m_width;
		this.mcHeight = m_height;
	}

	function toggleVisibility(doShow:Boolean):Void {
		var wItem = eval("_root.hitBoxes." + this.id);
		if(doShow == undefined) {
			doShow = !wItem._visible;
		}
		wItem._visible = doShow;
		wItem.hitBoxMC._visible = doShow;
		this.hitBoxMC._visible = doShow;
		this.visible = doShow;
	}
	
	function toggleActive(doActive:Boolean):Void {
		var wItem = eval("_root.hitBoxes" + this.id);
		if(doActive == undefined) {
			doActive = !wItem.active;
		}
		wItem.active = doActive;
		this.active = doActive;
	}
	
	function onHitBoxRelease():Void {
		var eventTodo:String;
		if(_global.gameMouse.isPickingUp) {
			eventTodo = this.eventPickUp;
		} else if (_global.gameMouse.isReady) {
			eventTodo = this.eventClick;
		} else if (_global.gameMouse.isUsingWith) {
			eventTodo = this.eventUseWith;
		} else if (_global.gameMouse.isUsing) {
			eventTodo = this.eventUse;
		} else if (_global.gameMouse.isOpening) {
			eventTodo = this.eventOpen;
		} else if (_global.gameMouse.isClosing) {
			eventTodo = this.eventClose;
		}
		
		var eHandler:EventHandler = new EventHandler();
		eHandler.handleEvent(eventTodo, this);
	}

	function onHitBoxRollOver():Void {
		if(this.name != undefined && this.name.length > 0) {
			_global.gameInfoBox.text = this.name;
		}
	}

	function onHitBoxRollOut():Void {
		_global.gameInfoBox.text = "";
	}	
}